#
# Conditional build:
%bcond_without	apidocs		# do not build and package API docs

Summary:	GObject and GUI library for high level crypto parsing and display
Summary(pl.UTF-8):	Biblioteka GObject i GUI do wysokopoziomowej analizy i wyświetlania danych kryptograficznych
Name:		gcr4
Version:	4.1.0
Release:	3
License:	LGPL v2+
Group:		X11/Applications
Source0:	https://download.gnome.org/sources/gcr/4.1/gcr-%{version}.tar.xz
# Source0-md5:	bb2e957f0ce11a8c527d1d5079ba485f
URL:		https://gitlab.gnome.org/GNOME/gcr
BuildRequires:	gettext-tools >= 0.19.8
BuildRequires:	glib2-devel >= 1:2.68
BuildRequires:	gobject-introspection-devel >= 1.34.0
BuildRequires:	gtk-doc >= 1.9
BuildRequires:	gtk4-devel >= 4
BuildRequires:	libgcrypt-devel >= 1.4.5
BuildRequires:	libsecret-devel >= 0.20
BuildRequires:	libtasn1-devel
BuildRequires:	libxslt-progs
BuildRequires:	meson >= 0.59
BuildRequires:	ninja >= 1.5
# to configure ssh-add,ssh-agent paths
BuildRequires:	openssh-clients
BuildRequires:	p11-kit-devel >= 0.19.0
BuildRequires:	pkgconfig
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpmbuild(macros) >= 2.011
BuildRequires:	systemd-devel
BuildRequires:	tar >= 1:1.22
BuildRequires:	vala >= 2:0.20.0
BuildRequires:	xz
Requires(post,preun,postun):	systemd-units >= 1:250.1
Requires:	gnupg2 >= 2.0
Requires:	libsecret >= 0.20
Requires:	systemd-units >= 1:250.1
Conflicts:	gnome-keyring < 3.3.0
Provides:	gcr = %{version}
Obsoletes:	gcr < 4
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
gcr is a library for displaying certificates, and crypto UI, accessing
key stores. It also provides a viewer for crypto files on the GNOME
desktop.

gck is a library for accessing PKCS#11 modules like smart cards.

%description -l pl.UTF-8
gcr to biblioteka do wyświetlania certyfikatów oraz kryptograficznego
interfejsu użytkownika, pozwalającego na dostęp do kluczy. Zapewnia
tekże przeglądarkę plików kryptograficznych dla środowiska GNOME.

gck to biblioteka dostepu do modułów PKCS#11, takich jak karty
procesorowe.

%package libs
Summary:	gcr and gck libraries
Summary(pl.UTF-8):	Biblioteki gcr i gck
Group:		Libraries
Requires:	glib2 >= 1:2.68
Requires:	libgcrypt >= 1.4.5
Requires:	p11-kit >= 0.19.0
Obsoletes:	gnome-keyring-libs < 3.3.0

%description libs
This package provides gcr and gck libraries.

%description libs -l pl.UTF-8
Ten pakiet dostarcza biblioteki gcr i gck.

%package devel
Summary:	Header files for gcr and gck libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek gcr i gck
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	glib2-devel >= 1:2.68
Requires:	p11-kit-devel >= 0.19.0
Obsoletes:	gcr-static < 3.36.0
Obsoletes:	gcr-ui-static < 3.36.0
Obsoletes:	gnome-keyring-devel < 3.3.0

%description devel
Header files for gcr and gck libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek gcr i gck.

%package -n vala-gcr4
Summary:	gcr and gck API for Vala language
Summary(pl.UTF-8):	API gcr i gck dla języka Vala
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Requires:	vala >= 2:0.20.0
BuildArch:	noarch

%description -n vala-gcr4
gcr and gck API for Vala language.

%description -n vala-gcr4 -l pl.UTF-8
API gcr i gck dla języka Vala.

%package apidocs
Summary:	gcr and gck API documentation
Summary(pl.UTF-8):	Dokumentacja API bibliotek gcr i gck
Group:		Documentation
Requires:	gtk-doc-common
Obsoletes:	gnome-keyring-apidocs < 3.3.0
BuildArch:	noarch

%description apidocs
API and gck documentation for gcr library.

%description apidocs -l pl.UTF-8
Dokumentacja API bibliotek gcr i gck.

%prep
%setup -q -n gcr-%{version}

%build
%meson build \
	-Dgpg_path=%{__gpg} \
	-Dgtk_doc=%{__true_false apidocs}

%ninja_build -C build

%install
rm -rf $RPM_BUILD_ROOT

%ninja_install -C build

# FIXME: where to package gi-docgen generated docs?
install -d $RPM_BUILD_ROOT%{_gtkdocdir}
%{__mv} $RPM_BUILD_ROOT%{_docdir}/{gck-2,gcr-4} $RPM_BUILD_ROOT%{_gtkdocdir}

# not supported by glibc (as of 2.37)
%{__rm} -r $RPM_BUILD_ROOT%{_localedir}/ie

%find_lang gcr-4

%clean
rm -rf $RPM_BUILD_ROOT

%post
%systemd_user_post gcr-ssh-agent.service

%preun
%systemd_user_preun gcr-ssh-agent.service

%postun
%systemd_user_postun_with_restart gcr-ssh-agent.service

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files -f gcr-4.lang
%defattr(644,root,root,755)
%doc CONTRIBUTING.md NEWS README.md
%attr(755,root,root) %{_bindir}/gcr-viewer-gtk4
%attr(755,root,root) %{_libexecdir}/gcr-ssh-agent
%attr(755,root,root) %{_libexecdir}/gcr4-ssh-askpass
%{systemduserunitdir}/gcr-ssh-agent.service
%{systemduserunitdir}/gcr-ssh-agent.socket

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libgck-2.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libgck-2.so.2
%attr(755,root,root) %{_libdir}/libgcr-4.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libgcr-4.so.4
%{_libdir}/girepository-1.0/Gck-2.typelib
%{_libdir}/girepository-1.0/Gcr-4.typelib

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libgck-2.so
%attr(755,root,root) %{_libdir}/libgcr-4.so
%{_datadir}/gir-1.0/Gck-2.gir
%{_datadir}/gir-1.0/Gcr-4.gir
%{_includedir}/gck-2
%{_includedir}/gcr-4
%{_pkgconfigdir}/gck-2.pc
%{_pkgconfigdir}/gcr-4.pc

%files -n vala-gcr4
%defattr(644,root,root,755)
%{_datadir}/vala/vapi/gck-2.deps
%{_datadir}/vala/vapi/gck-2.vapi
%{_datadir}/vala/vapi/gcr-4.deps
%{_datadir}/vala/vapi/gcr-4.vapi

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%{_gtkdocdir}/gck-2
%{_gtkdocdir}/gcr-4
%endif
%changelog
* Fri Jun 02 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/gcr4.git;a=log;h=master

* Fri Jun 02 2023 Jan Rękorajski <baggins@pld-linux.org> b7cc59a
- provide versioned gcr for older packages that need the agent, rel 3

* Fri Mar 24 2023 Jakub Bogusz <qboosh@pld-linux.org> f58527a
- drop ie locale; release 2

* Thu Mar 23 2023 Jakub Bogusz <qboosh@pld-linux.org> 7031b88
- updated to 4.1.0 (sonames mess fixed, thus changed)

* Thu Oct 20 2022 Jakub Bogusz <qboosh@pld-linux.org> 4ac44cb
- updated to 4.0.0

* Wed Sep 07 2022 Jakub Bogusz <qboosh@pld-linux.org> a8a8efb
- gcr updated to 3.92.0 for gtk4; libs are parallel-installable with gcr 3.x, agent is replacement

* Sat Apr 23 2022 Jan Palus <atler@pld-linux.org> 1b032ad
- upstream patch to fix build with meson >= 0.61

* Mon Feb 28 2022 Jakub Bogusz <qboosh@pld-linux.org> 556163b
- systemd epoch

* Sat Jan 08 2022 Jan Rękorajski <baggins@pld-linux.org> 7c86cfb
- Release 4 (by relup.sh)

* Sat Jan 08 2022 Jan Rękorajski <baggins@pld-linux.org> 3ab9867
- update ssh BR

* Sat Jan 08 2022 Jan Rękorajski <baggins@pld-linux.org> d229852
- fix meson option name, rel 3

* Sat Jan 08 2022 Jan Rękorajski <baggins@pld-linux.org> ea13492
- add systemd user service startup, rel 2

* Thu Sep 30 2021 Jakub Bogusz <qboosh@pld-linux.org> 1f4d05f
- updated to 3.41.0

* Wed Mar 31 2021 Jakub Bogusz <qboosh@pld-linux.org> 865f213
- rpm-build and ninja versions

* Sat Mar 27 2021 Jan Palus <atler@pld-linux.org> fff9f18
- up to 3.40.0

* Sun Mar 07 2021 Jan Rękorajski <baggins@pld-linux.org> dc372bf
- unconditional noarch subpackages

* Wed Jan 13 2021 Jakub Bogusz <qboosh@pld-linux.org> 83328cd
- updated noarch rules and GNOME Source URL

* Wed Jan 13 2021 Jan Palus <atler@pld-linux.org> 70d045a
- up to 3.38.1

* Mon Sep 28 2020 Jan Palus <atler@pld-linux.org> 52e6af5
- up to 3.38.0

* Sun Apr 12 2020 Jakub Bogusz <qboosh@pld-linux.org> c4e396c
- vala-gcr-ui as noarch, force gnupg2

* Fri Mar 13 2020 Jan Palus <atler@pld-linux.org> 8863292
- move O: *-static to -devel

